<?php
/**
* @version $Id: module.class.php,v 1.10 2004/09/06 03:44:36 eddieajau Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
* @subpackage Installer
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* Module installer
* @package Mambo_4.5.1
*/
class mosInstallerModule extends mosInstaller {
	/**
	* Custom install method
	* @param boolean True if installing from directory
	*/
	function install( $p_fromdir = null ) {
		global $mosConfig_absolute_path, $database;

		if (!$this->preInstallCheck( $p_fromdir, 'module' )) {
			return false;
		}

		$xml = $this->xmlDoc();
		$mosinstall =& $xml->documentElement;

		$client = '';
		if ($mosinstall->getAttribute( 'client' )) {
		    $validClients = array( 'administrator' );
			if (!in_array( $mosinstall->getAttribute( 'client' ), $validClients )) {
				$this->setError( 1, 'Unknown client type ['.$mosinstall->getAttribute( 'client' ).']' );
				return false;
			}
			$client = 'admin';
		}

		// Set some vars
		$e = &$xml->getElementsByPath('name',1);
		$this->elementName($e->getText());
		$this->elementDir( mosPathName( $mosConfig_absolute_path
		    . ($client == 'admin' ? '/administrator' : '')
			. '/modules/' )
		);

		if ($this->parseFiles( 'files', 'module', 'No file is marked as module file' ) === false) {
		    return false;
		}
		$this->parseFiles( 'images' );

		$client_id = intval( $client == 'admin' );
		// Insert in module in DB
		$database->setQuery( "SELECT id FROM #__modules"
			. "\nWHERE module = '" . $this->elementSpecial() . "' AND client_id=$client_id" );
		if (!$database->query()) {
			$this->setError( 1, 'SQL error: ' . $database->stderr( true ) );
			return false;
		}

		$id = $database->loadResult();

		if (!$id) {
			$row = new mosModule( $database );
			$row->title = $this->elementName();
			$row->ordering = 99;
			$row->position = 'left';
			$row->showtitle = 1;
			$row->iscore = 0;
			$row->access = $client == 'admin' ? 99 : 0;
			$row->client_id = $client_id;
			$row->module = $this->elementSpecial();

			$row->store();

			$database->setQuery( "INSERT INTO #__modules_menu VALUES ('$row->id', 0)" );
			if(!$database->query()) {
				$this->setError( 1, 'SQL error: ' . $database->stderr( true ) );
				return false;
			}
		} else {
			$this->setError( 1, 'Module "' . $this->elementName() . '" already exists!' );
			return false;
		}
		if ($e = &$xml->getElementsByPath( 'description', 1 )) {
			$this->setError( 0, $this->elementName() . '<p>' . $e->getText() . '</p>' );
		}

		return $this->copySetupFile();
	}
	/**
	* Custom install method
	* @param int The id of the module
	* @param string The URL option
	* @param int The client id
	*/
	function uninstall( $id, $option, $client=0 ) {
		global $database, $mosConfig_absolute_path;

		$id = intval( $id );

		$database->setQuery( "SELECT module, iscore, client_id FROM #__modules WHERE id = '$id'" );

		$row = null;
		$database->loadObject( $row );

		if ($row->iscore) {
			HTML_installer::showInstallMessage( $row->title . 'is a core module, and can not be uninstalled.<br />You need to unpublish it if you don\'t want to use it',
				'Uninstall -  error', $this->returnTo( $option, 'module', $row->client_id ? '' : 'admin' ) );
			exit();
		}

		$database->setQuery( "SELECT id FROM #__modules WHERE module = '$row->module'" );
		$modules = $database->loadResultArray();

		if (count( $modules )) {
			$database->setQuery( "DELETE FROM #__modules_menu"
				. "\nWHERE moduleid IN ('".implode( "','", $modules ) ."')"
			);
			if (!$database->query()) {
			    $msg = $database->stderr;
			    die( $msg );
			}
		}

		$database->setQuery( "DELETE FROM #__modules WHERE module = '$row->module'" );
		if (!$database->query()) {
		    $msg = $database->stderr;
		    die( $msg );
		}

		// delete the module file
		if (trim( $row->module )) {
	        $file = $mosConfig_absolute_path
	        	. ($row->client_id == 1 ? '/administrator' : '')
				. '/modules/' . $row->module . '.php';
			$file = mosPathName( $file, false );
	    	if (is_file( $file )) {
				@unlink( mosPathName( $mosConfig_absolute_path . "/modules/" . $row->module . '.xml', false ) );
				return unlink( $file );
			} else {
				HTML_installer::showInstallMessage( 'Attemping to delete a directory', 'Uninstall -  error',
					$this->returnTo( $option, 'module', $client ));
				exit();
			}
		} else {
			HTML_installer::showInstallMessage( 'Module file name empty, cannot remove files', 'Uninstall -  error',
				$this->returnTo( $option, 'module', $client ) );
			exit();
		}
	}
}
?>